diff --git a/build.gradle.kts b/build.gradle.kts
index 9cea777e6..4f9c18d05 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -146,6 +146,7 @@ dependencies {
     implementation("com.github.JnCrMx:discord-game-sdk4j:v0.5.5")?.let { clientInclude(it) }
 
     implementation("objects:client:43db9b498cb67058d2e12d394e6507722e71bb45") // Minecraft client jar
+    implementation("com.mojang:brigadier:1.0.18")?.let { clientInclude(it); serverInclude(it) }
 
     implementation("com.formdev:flatlaf:3.1.1")?.let { clientInclude(it) } // Dark theme used by SeedViewer
     
@@ -179,7 +180,9 @@ task("runClient", JavaExec::class) {
     group = "bta"
     mainClass.set("net.minecraft.client.Minecraft")
     classpath = sourceSets["main"].runtimeClasspath
-    jvmArgs = listOf("-XstartOnFirstThread", "-Djava.awt.headless=true")
+    if (arrayOf("Mac OS X", "Darwin").any { System.getProperty("os.name").startsWith(it) }) {
+        jvmArgs = listOf("-XstartOnFirstThread", "-Djava.awt.headless=true")
+    }
 
     systemProperty("java.library.path", layout.buildDirectory.dir("natives").get().asFile.absolutePath)
 }
diff --git a/src/common/resources/lang/en_US/command.lang b/src/common/resources/lang/en_US/command.lang
new file mode 100644
index 000000000..dc37e72b7
--- /dev/null
+++ b/src/common/resources/lang/en_US/command.lang
@@ -0,0 +1,163 @@
+command.argument_types.achievement.invalid_achievement=Invalid achievement ID
+command.argument_types.entity_summon.invalid_entity=Invalid entity ID
+command.argument_types.block.invalid_block=Invalid block ID
+command.argument_types.item.invalid_item=Invalid item ID
+command.argument_types.dimension.invalid_dimension=Invalid dimension ID
+command.argument_types.biome.invalid_biome=Invalid biome ID
+command.argument_types.damage_type.invalid_damage_type=Invalid damage type ID
+command.argument_types.gamerule.invalid_value=Invalid game rule value
+command.argument_types.sound_type.invalid_sound_type=Invalid sound type
+command.argument_types.sound_category.invalid_sound_category=Invalid sound category
+command.argument_types.entity.invalid_selector.single_player_only=Selector includes more than one entity, but command only accepts a single player as an argument
+command.argument_types.entity.invalid_selector.single_entity_only=Selector includes more than one entity, but command only accepts a single entity as an argument
+command.argument_types.entity.invalid_selector.player_only=Selector includes non-player entities, but command only accepts players as an argument
+command.argument_types.entity.invalid_selector.generic=Invalid selector
+command.argument_types.entity.invalid_selector.empty=No entities match the given selector
+command.argument_types.entity.invalid_selector.selectors_not_allowed=Selectors not allowed
+command.argument_types.entity.selector.nearest_player=Nearest player
+command.argument_types.entity.selector.all_players=All players
+command.argument_types.entity.selector.random_player=Random player
+command.argument_types.entity.selector.self=Current entity
+command.argument_types.entity.selector.all_entities=All entities
+command.argument_types.entity.selector.options.inapplicable=Option '%s' isn't applicable here
+command.argument_types.entity.selector.options.unknown=Unknown option '%s'
+command.argument_types.entity.selector.options.unterminated=Expected end of options
+command.argument_types.entity.selector.options.valueless=Expected value for option '%s'
+command.argument_types.entity.selector.options.gamemode.invalid=Invalid or unknown game mode '%s'
+command.argument_types.entity.selector.options.gamemode.description=Players with game mode
+command.argument_types.entity.selector.options.nbt.description=Entities with NBT
+command.argument_types.entity.selector.options.sort.description=Sort the entities
+command.argument_types.entity.selector.options.sort.invalid=Invalid or unknown sort type '%s'
+command.argument_types.entity.selector.options.limit.description=Maximum number of entities to return
+command.argument_types.entity.selector.options.limit.invalid=Limit must be at least 1
+command.argument_types.entity.selector.options.type.description=Entities of type
+command.argument_types.entity.selector.options.type.invalid=Invalid or unknown entity type '%s'
+command.argument_types.entity.selector.options.distance.description=Distance to entity
+command.argument_types.entity.selector.options.distance.invalid=Distance cannot be negative
+command.argument_types.entity.selector.options.name.description=Entity name
+command.argument_types.entity.selector.options.x.description=x position
+command.argument_types.entity.selector.options.y.description=y position
+command.argument_types.entity.selector.options.z.description=z position
+command.argument_types.entity.selector.options.dx.description=Entities between x and x + dx
+command.argument_types.entity.selector.options.dy.description=Entities between y and y + dy
+command.argument_types.entity.selector.options.dz.description=Entities between z and z + dz
+command.exceptions.tag.valueless=Expected value for tag key '%s'
+command.argument_types.item_stack.tag.invalid=Invalid tag key value; must be an integer, floating point, double-precision floating point, boolean or string value
+command.exceptions.metadata.unterminated=Expected end of metadata
+command.exceptions.tag.unterminated=Expected end of tag
+command.argument_types.range.empty=Expected value or range of values
+command.argument_types.range.swapped=Min cannot be bigger than max
+command.argument_types.time.invalid_unit=Invalid unit
+command.argument_types.time.tick_count_too_low=Tick count must not be less than %s, found %s
+command.argument_types.game_mode.invalid_game_mode=Invalid game mode
+command.argument_types.weather.invalid_weather=Invalid weather
+command.argument_types.world_feature.invalid_world_feature=Invalid world feature
+command.argument_types.world_feature.no_parameters=The given world feature expects no parameters
+command.commands.time.query=The time is %s
+command.commands.time.set=Set the time to %s
+command.commands.achievement.grant.exception_already_has_achievement=Player already has achievement
+command.commands.achievement.grant.success_multiple_entities=Granted achievement §5[%s]§r to %s entities
+command.commands.achievement.grant.success_single_entity=Granted achievement §5[%s]§r to %s
+command.commands.achievement.grant.all.success_multiple_entities=Granted all achievements to %s entities
+command.commands.achievement.grant.all.success_single_entity=Granted all achievements to %s
+command.commands.seed.success=Seed: §5[%s]§r
+command.commands.clear.success_single_item_single_entity=%s item slot cleared
+command.commands.clear.success_multiple_items_single_entity=%s item slots cleared
+command.commands.clear.success_single_item_multiple_entities=%s item slot cleared from %s entities
+command.commands.clear.success_multiple_items_multiple_entities=%s item slots cleared from %s entities
+command.commands.clear.exception_failure=No items were cleared
+command.commands.kill.single_entity=Killed %s
+command.commands.kill.multiple_entities=Killed %s entities
+command.commands.kill.exception_failure=No entity was killed
+command.commands.summon.success_single_entity=Summoned %s
+command.commands.summon.success_multiple_entities=Summoned %s entities
+command.commands.teleport.entity.success_single_entity=Teleported %s to %s
+command.commands.teleport.entity.success_multiple_entities=Teleported %s entities to %s
+command.commands.teleport.location.success_single_entity=Teleported %s to %s, %s, %s
+command.commands.teleport.location.success_multiple_entities=Teleported %s entities to %s, %s, %s
+command.commands.setblock.exception_failure=Could not set the block
+command.commands.setblock.success=Changed the block at %s, %s, %s
+command.commands.message.incoming=%s whispers to you: %s
+command.commands.message.outgoing=You whisper to %s: %s
+command.commands.gamemode.success_self=Set own game mode to %s
+command.commands.gamemode.success_other=Set %s's game mode to %s
+command.commands.gamemode.success_receiver=Your game mode has been updated
+command.commands.weather.success=Set the weather to %s
+command.commands.spawn.success=Teleported yourself to the world's spawn point
+command.commands.spawn.success_other=Teleported %s to the world's spawn point
+command.commands.spawn.success_receiver=You were teleported to the world's spawn point
+command.commands.spawn.get=The world's spawn point is located at %s, %s, %s
+command.commands.place.success=Placed feature %s at %s, %s, %s
+command.commands.place.exception_failure=Could not place feature
+command.commands.help.exception_failure=Unknown command or insufficient permissions
+command.commands.give.success_single_entity=Gave %s %s * [%s§r]
+command.commands.give.success_multiple_entities=Gave %s players %s * [%s§r]
+command.commands.stop.success=Stopping the server
+command.commands.op.success=%s is now a server operator
+command.commands.op.success_receiver=You are now a server operator
+command.commands.op.exception_failure=Nothing changed, all players in the given selector are already server operators
+command.commands.deop.success=%s is no longer a server operator
+command.commands.deop.success_receiver=You are no longer a server operator
+command.commands.deop.exception_failure=Nothing changed, there are no server operators in the given selector
+command.commands.list.success_single=There is %s player online: %s
+command.commands.list.success_multiple=There are %s players online: %s
+command.commands.list.success_too_long=There are %s players online; number is too large to show all of them
+command.commands.list.exception_failure=There are no players online
+command.commands.difficulty.query.success=The difficulty is %s
+command.commands.difficulty.query.success_unknown=The difficulty is unknown
+command.commands.difficulty.set.success=Set the game's difficulty to %s
+command.commands.color.get.success=Your color is %s
+command.commands.color.get.success_other=%s's color is %s
+command.commands.color.set.success=Set own color to %s
+command.commands.color.set.success_other=Set %s's color to %s
+command.commands.color.set.success_receiver=Your color has been set to %s
+command.commands.nickname.exception_too_large=The given nickname is too large, should be less than 16 characters
+command.commands.nickname.exception_too_small=The given nickname is too small, should have at least one character
+command.commands.nickname.set.success=Set own nickname to %s
+command.commands.nickname.set.success_other=Set %s's nickname to %s
+command.commands.nickname.set.success_receiver=Your nickname has been set to %s
+command.commands.nickname.get.success=%s's nickname is %s
+command.commands.nickname.reset.success=Reset own nickname
+command.commands.nickname.reset.success_other=Reset %s's nickname
+command.commands.nickname.reset.success_receiver=Your nickname has been reset
+command.commands.chunk.reset.success=Reset chunk at %s, %s
+command.commands.setspawn.success=Set world spawn point to %s, %s, %s
+command.commands.whois.success=%s's username is %s
+command.commands.score.get.success=Your score is %s
+command.commands.score.get.success_other=%s's score is %s
+command.commands.score.set.success=Set own score to %s
+command.commands.score.set.success_other=Set %s's score to %s
+command.commands.score.set.success_receiver=Your score has been set to %s
+command.commands.emotes.success=Available emotes:
+command.commands.gamerule.get=Game rule %s is set to %s
+command.exceptions.incomplete=Incomplete argument
+command.exceptions.not_in_world=Argument requires sender to be in world, but they are not present
+command.exceptions.single_player_world_only=Command requires the sender to be in a single player world
+command.exceptions.multiplayer_world_only=Command requires the sender to be in a multiplayer world
+command.commands.gamerule.set=Set game rule %s to %s
+command.exceptions.volume_too_large=Volume is too large (the maximum 32768 blocks)
+command.commands.fill.success_single=Filled %s block
+command.commands.fill.success_multiple=Filled %s blocks
+command.commands.clone.exception_inside_cloned_area=Destination is inside the cloned area
+command.commands.clone.exception_destination_not_loaded=Destination is not loaded
+command.commands.clone.exception_source_not_loaded=Source is not loaded
+command.commands.clone.exception_nowhere_loaded=Source and destination are not loaded
+command.commands.clone.success_single=%s block cloned
+command.commands.clone.success_multiple=%s blocks cloned
+command.commands.biome.locate.exception_failure=Could not find biome %s at any reasonable distance
+command.commands.biome.locate.success=Biome %s found in position §5[%s, ~, %s]§r
+command.commands.biome.locate.success_in_world_single=Biome %s found in position §5[%s, ~, %s]§r (%s block away)
+command.commands.biome.locate.success_in_world_multiple=Biome %s found in position §5[%s, ~, %s]§r (%s blocks away)
+command.commands.biome.get.success=The biome at position %s, %s, %s is %s
+command.commands.testfor.entity.none=No entities match the given selector
+command.commands.testfor.entity.single=%s entity matches the given selector
+command.commands.testfor.entity.plural=%s entities match the given selector
+command.commands.testfor.block.success=The two blocks are equal
+command.commands.testfor.block.failure=The two blocks are not equal
+command.commands.damage.success_single=Damaged %s entity
+command.commands.damage.success_multiple=Damaged %s entities
+command.commands.heal.success_single=Healed %s entity
+command.commands.heal.success_multiple=Healed %s entities
+command.commands.playsound.success=Played sound %s in category %s at %s, %s, %s
+command.commands.playsound.exception_failure=Could not play sound %s
+command.commands.spawnparticle.success=Spawned particle %s at %s, %s, %s
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 73400c5fa..d9d1eaf00 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -21,8 +21,11 @@ import com.mojang.nbt.CompoundTag;
 import net.minecraft.client.entity.ClientSkinVariantList;
 import net.minecraft.client.gui.*;
 import net.minecraft.client.gui.achievements.AchievementsScreen;
+import net.minecraft.client.gui.chat.ChatScreen;
+import net.minecraft.client.gui.chat.SleepScreenMP;
 import net.minecraft.client.gui.toasts.HudToastsElement;
 import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.util.helper.LoggedPrintStream;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.core.world.SpawnerMobs;
@@ -118,7 +121,6 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.PlayerProfile;
-import net.minecraft.core.net.command.ClientCommandHandler;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.player.Session;
 import net.minecraft.core.player.gamemode.Gamemode;
@@ -239,7 +241,6 @@ public class Minecraft
     protected long flyPressedTime = 0;
     public float hotbarSwapAnimationProgress = 0.0f;
     public ScaledResolution resolution;
-    public final ClientCommandHandler commandHandler = new ClientCommandHandler(this);
     public boolean fullbright = false;
     public Renderer renderer;
     public ControllerInput controllerInput;
@@ -407,8 +408,8 @@ public class Minecraft
         // Manually initialize blocks and items
         Blocks.init();
         Items.init();
-
         Dimension.init();
+        CommandHelper.init();
 
 		gameSettings = new GameSettings(this, mcDataDir);
 
diff --git a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
index 1ab8f1887..745fc3481 100644
--- a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.entity.player;
 
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.logging.LogUtils;
 import com.mojang.nbt.CompoundTag;
 
@@ -35,12 +36,8 @@ import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.command.ClientCommandHandler;
-import net.minecraft.core.net.command.ClientPlayerCommandSender;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.Commands;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.client.net.command.ClientCommandSource;
 import net.minecraft.core.player.Session;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.menu.InventoryMenu;
@@ -57,14 +54,12 @@ public class LocalPlayer extends Player
     private static final Logger LOGGER = LogUtils.getLogger();
     public PlayerInput input;
     protected Minecraft mc;
-    public final ClientPlayerCommandSender sender;
     protected int sprintTimer;
 
     public LocalPlayer(Minecraft minecraft, World world, Session session, int dimension)
     {
         super(world);
         mc = minecraft;
-        sender = new ClientPlayerCommandSender(minecraft, this);
         this.dimension = dimension;
         username = session.username;
         uuid = session.uuid;
@@ -342,35 +337,12 @@ public class LocalPlayer extends Player
     public void sendChatMessage(String s) {
     	addToSendHistory(s);
         if (s.startsWith("/")) {
-            try{
-                String[] args = s.substring(1).split(" ");
-                String[] args1 = new String[args.length - 1];
-                System.arraycopy(args, 1, args1, 0, args.length - 1);
-
-                ClientCommandHandler handler = mc.commandHandler;
-
-                for(Command command : Commands.commands) {
-                    if(command.isName(args[0])) {
-                        if(!sender.isAdmin() && command.opRequired(args1)) {
-                            sender.sendMessage("You don't have permission to use this command!");
-                            return;
-                        }
-                        try {
-                            boolean success = command.execute(handler, sender, args1);
-                            if(!success) {
-                                command.sendCommandSyntax(handler, sender);
-                            }
-                        }catch (CommandError e) {
-                            sender.sendMessage(TextFormatting.RED + e.getMessage());
-                        }
-                        return;
-                    }
-                }
-                sender.sendMessage(TextFormatting.RED + "Command '" + args[0] + "' does not exist!");
-            }catch (Exception e) {
-                LOGGER.error("Exception while trying to perform command '" + s + "'!", e);
-                mc.ingameHud.addChatMessage(TextFormatting.RED + "Error!");
-                mc.ingameHud.addChatMessage(TextFormatting.RED + e.getMessage());
+            String command = s.substring(1);
+            ClientCommandSource clientCommandSource = new ClientCommandSource(mc);
+            try {
+                this.world.getCommandManager().execute(command, clientCommandSource);
+            } catch (CommandSyntaxException e) {
+                mc.thePlayer.sendMessage(TextFormatting.RED + e.getMessage());
             }
         } else {
             mc.ingameHud.addChatMessage("<" + getDisplayName() + TextFormatting.RESET + "> " + TextFormatting.WHITE + s);
diff --git a/src/main/java/net/minecraft/client/gui/ItemElement.java b/src/main/java/net/minecraft/client/gui/ItemElement.java
index c613e0079..e2fb3ba1c 100644
--- a/src/main/java/net/minecraft/client/gui/ItemElement.java
+++ b/src/main/java/net/minecraft/client/gui/ItemElement.java
@@ -14,7 +14,7 @@ import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.GuidebookSlot;
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 
diff --git a/src/main/java/net/minecraft/client/gui/TooltipElement.java b/src/main/java/net/minecraft/client/gui/TooltipElement.java
index a323d73db..9bc2f815f 100644
--- a/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -12,7 +12,7 @@ import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.ResultSlot;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.player.inventory.slot.GuidebookSlot;
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
diff --git a/src/main/java/net/minecraft/client/gui/ChatEmotePickerElement.java b/src/main/java/net/minecraft/client/gui/chat/ChatEmotePickerElement.java
similarity index 98%
rename from src/main/java/net/minecraft/client/gui/ChatEmotePickerElement.java
rename to src/main/java/net/minecraft/client/gui/chat/ChatEmotePickerElement.java
index 69cecf1cc..261302c7f 100644
--- a/src/main/java/net/minecraft/client/gui/ChatEmotePickerElement.java
+++ b/src/main/java/net/minecraft/client/gui/chat/ChatEmotePickerElement.java
@@ -1,6 +1,7 @@
-package net.minecraft.client.gui;
+package net.minecraft.client.gui.chat;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.Gui;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.ChatEmotes;
diff --git a/src/main/java/net/minecraft/client/gui/ChatScreen.java b/src/main/java/net/minecraft/client/gui/chat/ChatScreen.java
similarity index 54%
rename from src/main/java/net/minecraft/client/gui/ChatScreen.java
rename to src/main/java/net/minecraft/client/gui/chat/ChatScreen.java
index 51462267d..ded531c91 100644
--- a/src/main/java/net/minecraft/client/gui/ChatScreen.java
+++ b/src/main/java/net/minecraft/client/gui/chat/ChatScreen.java
@@ -1,6 +1,9 @@
-package net.minecraft.client.gui;
+package net.minecraft.client.gui.chat;
 
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.hud.component.ComponentAnchor;
 import net.minecraft.client.gui.text.TextFieldEditor;
+import net.minecraft.client.render.Font;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.ChatEmotes;
 import org.lwjgl.input.Keyboard;
@@ -17,6 +20,7 @@ public class ChatScreen extends Screen implements ITextField {
 	private final TextFieldEditor editor;
 	protected ChatEmotePickerElement emotePicker;
 	protected boolean showEmotePicker = false;
+	private ChatSuggestionsElement suggestionsElement;
 
 	public ChatScreen() {
 		this("");
@@ -35,6 +39,20 @@ public class ChatScreen extends Screen implements ITextField {
 		int emotePickerYCells = (int)MathHelper.clamp(Math.ceil(ChatEmotes.getEmotes().size() / 5.0), 0, 4);
 		emotePicker = new ChatEmotePickerElement(mc, this, 5, emotePickerYCells);
 		showEmotePicker = false;
+		suggestionsElement = new ChatSuggestionsElement(
+			mc,
+			editor,
+			this,
+			(parent, child, minecraft, followParameters) -> 16 + (followParameters ? suggestionsElement.getDefaultParameterPosition() - 1 : 0),
+			(parent, child, minecraft, followParameters) -> minecraft.resolution.getScaledHeightScreenCoords() - 14,
+			ComponentAnchor.BOTTOM_LEFT
+		);
+		if (!this.getText().startsWith("/")) {
+			this.suggestionsElement.hidden = true;
+		} else {
+			this.suggestionsElement.updateSuggestions();
+		}
+
 	}
 
 	@Override
@@ -56,45 +74,73 @@ public class ChatScreen extends Screen implements ITextField {
 				mc.ingameHud.chatScroll += dWheel / 1;
 			}
 		}
+
+		if (this.suggestionsElement != null) {
+			this.suggestionsElement.hidden = !this.getText().startsWith("/");
+			this.suggestionsElement.updateScreen(dWheel);
+		}
 	}
 
 	@Override
 	public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
-		if (eventKey == Keyboard.KEY_UP && mc.thePlayer.messageHistory.size() > 0) {
-			if (currentIndex == 0)
-			{
-				originalMessage = getText();
+		boolean handled = false;
+
+		if (eventKey == Keyboard.KEY_UP) {
+			if (this.suggestionsElement != null) {
+				if (this.suggestionsElement.getCommandIndex() != -1) {
+					this.suggestionsElement.cycleThroughSuggestions(-1);
+					handled = true;
+				}
 			}
-			if (currentIndex < mc.thePlayer.messageHistory.size())
-			{
-				currentIndex++;
-				setText(getMessage(currentIndex));
-				this.editor.setCursor(10000);
+			if (!handled && !mc.thePlayer.messageHistory.isEmpty()) {
+				if (currentIndex == 0)
+				{
+					originalMessage = getText();
+				}
+				if (currentIndex < mc.thePlayer.messageHistory.size())
+				{
+					currentIndex++;
+					setText(getMessage(currentIndex));
+					this.editor.setCursor(10000);
+				}
+				editor.setCursor(10000);
+				if (this.suggestionsElement != null) {
+					this.suggestionsElement.updateSuggestions();
+				}
+				handled = true;
 			}
-			editor.setCursor(10000);
-			return;
 		}
-		if (eventKey == Keyboard.KEY_DOWN && currentIndex > 0)
+		if (eventKey == Keyboard.KEY_DOWN)
 		{
-			if (currentIndex-1 == 0)
-			{
-				currentIndex--;
-				setText(originalMessage);
-				this.editor.setCursor(10000);
-
+			if (this.suggestionsElement != null) {
+				if (this.suggestionsElement.getCommandIndex() != -1) {
+					this.suggestionsElement.cycleThroughSuggestions();
+					handled = true;
+				}
 			}
-			else
-			{
-				currentIndex--;
-				setText(getMessage(currentIndex));
-				this.editor.setCursor(10000);
+			if (!handled && currentIndex > 0) {
+				if (currentIndex-1 == 0)
+				{
+					currentIndex--;
+					setText(originalMessage);
+					this.editor.setCursor(10000);
+				}
+				else
+				{
+					currentIndex--;
+					setText(getMessage(currentIndex));
+					this.editor.setCursor(10000);
+				}
+				editor.setCursor(10000);
+				if (this.suggestionsElement != null) {
+					this.suggestionsElement.updateSuggestions();
+				}
+				handled = true;
 			}
-			editor.setCursor(10000);
-			return;
 		}
 		if (eventKey == Keyboard.KEY_ESCAPE && !(this instanceof SleepScreenMP)) {
 			mc.displayScreen(null);
-			return;
+			handled = true;
 		}
 		if (eventKey == Keyboard.KEY_RETURN) {
 			String s = message.trim();
@@ -103,9 +149,14 @@ public class ChatScreen extends Screen implements ITextField {
 				mc.thePlayer.sendChatMessage(s1);
 			}
 			mc.displayScreen(null);
-			return;
+			handled = true;
+		}
+		if (!handled) {
+			editor.handleInput(eventKey, eventCharacter);
+		}
+		if (this.suggestionsElement != null) {
+			this.suggestionsElement.keyTyped(eventCharacter, eventKey);
 		}
-		editor.handleInput(eventKey, eventCharacter);
 	}
 
 	@Override
@@ -123,9 +174,10 @@ public class ChatScreen extends Screen implements ITextField {
 
 		drawRect(16, height - 14, width - 2, height - 2, 0x80000000);
 
+		font.drawStringWithShadow(this.suggestionsElement.getSuggestionPreview(), 16 + suggestionsElement.getDefaultParameterPosition(), mc.resolution.getScaledHeightScreenCoords() - 12, 0xFFFFFF);
 		boolean drawCursor = (updateCounter / 6) % 2 == 0;
 		int cursor = editor.getCursor();
-		drawString(font, message, 18, height - 12, 0xE0E0E0);
+		drawString(font, this.suggestionsElement.colorCodeText(message, true), 18, height - 12, 0xE0E0E0);
 		if (drawCursor)
 		{
 			int width = font.getStringWidth(message);
@@ -141,22 +193,31 @@ public class ChatScreen extends Screen implements ITextField {
 		}
 
 		super.render(xm, ym, partialTick);
+		if (this.suggestionsElement != null) {
+			this.suggestionsElement.drawScreen();
+		}
 	}
 
 	@Override
 	public void mouseClicked(int mx, int my, int buttonNum) {
 		super.mouseClicked(mx, my, buttonNum);
+		boolean handled = false;
 		if (buttonNum == 0) {
 			if (mx >= 2 && mx < 14 && my >= height - 14 && my < height - 2) {
 				showEmotePicker = !showEmotePicker;
-				return;
+				handled = true;
 			}
-			if (showEmotePicker) {
+			if (!handled && showEmotePicker) {
 				Character c = emotePicker.click(mx - 2, my - (height - 16 - emotePicker.getHeight()));
 				if (c != null) {
 					editor.handleInput(0, c);
 					if (!Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) && !Keyboard.isKeyDown(Keyboard.KEY_RSHIFT)) showEmotePicker = false;
-					return;
+					handled = true;
+				}
+			}
+			if (!handled) {
+				if (this.suggestionsElement != null) {
+					this.suggestionsElement.mouseClicked(mx, my, buttonNum);
 				}
 			}
 		}
